﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinSchedule;
using System.Diagnostics;
//using GanttChart.Model;

namespace BindingGanttView
{
    public partial class BindingGanttView : Form
    {
        public BindingGanttView()
        {
            InitializeComponent();
        }

        private void BindingGanttView_Load(object sender, EventArgs e)
        {

            //  Set the BindingContextControl property to reference this form
            this.ultraCalendarInfo1.DataBindingsForTasks.BindingContextControl = this;
            this.ultraCalendarInfo1.DataBindingsForProjects.BindingContextControl = this;

            // Set the DataSource and DataMember for Project and Tasks using the SetDataBinding method
            this.ultraCalendarInfo1.DataBindingsForProjects.SetDataBinding(ProjectRepository.Instance.projectPlanRepo, "Plans");
            this.ultraCalendarInfo1.DataBindingsForTasks.SetDataBinding(ProjectRepository.Instance.projectPlanRepo, "Tasks");

            //  Set the DataBinding members for Projects 
            this.ultraCalendarInfo1.DataBindingsForProjects.IdMember = "PlanGuid";
            this.ultraCalendarInfo1.DataBindingsForProjects.KeyMember = "PlanID";
            this.ultraCalendarInfo1.DataBindingsForProjects.NameMember = "PlanName";
            this.ultraCalendarInfo1.DataBindingsForProjects.StartDateMember = "PlanStartTime";

            //  Set the DataBinding members for Tasks
            // Basic Task properties 
            this.ultraCalendarInfo1.DataBindingsForTasks.NameMember = "TaskName";
            this.ultraCalendarInfo1.DataBindingsForTasks.DurationMember = "TaskDuration";
            this.ultraCalendarInfo1.DataBindingsForTasks.StartDateTimeMember = "TaskStartTime";
            this.ultraCalendarInfo1.DataBindingsForTasks.IdMember = "TaskGuid";
            this.ultraCalendarInfo1.DataBindingsForTasks.ProjectKeyMember = "PlanID";
            this.ultraCalendarInfo1.DataBindingsForTasks.ParentTaskIdMember = "ParentTaskGuid";
            this.ultraCalendarInfo1.DataBindingsForTasks.PercentCompleteMember = "TaskPercentComplete";
            this.ultraCalendarInfo1.DataBindingsForTasks.AllPropertiesMember = "AllProperties";

            // All other properties
            this.ultraCalendarInfo1.DataBindingsForTasks.AllPropertiesMember = "AllProperties";

            //  Since we are showing a task that belongs to an explicitly defined
            //  project (i.e., not the UnassignedProject), assign that project to
            //  the control's Project property so the control knows to display that project.
            this.ultraGanttView1.CalendarInfo = this.ultraCalendarInfo1;
            Project project = new Project();
            project.Key = ProjectRepository.Instance.defaultProjectName;
            project.Name = ProjectRepository.Instance.defaultProjectName;
            project.StartDate = DateTime.Now;
            this.ultraCalendarInfo1.Projects.Add(project);
            this.ultraGanttView1.Project = this.ultraGanttView1.CalendarInfo.Projects[1];
            dataGridView1.DataSource = ProjectRepository.Instance.projectPlanRepo;
            dataGridView1.DataMember = "Tasks";

        }

        private void ultraCalendarInfo1_TaskDataInitialized(object sender, TaskDataInitializedEventArgs e)
        {
            Debug.WriteLine(e.Task.Name);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Debug.WriteLine("Rows {0}", ProjectRepository.Instance.theTasks.Rows.Count);
        }
    }
}
