using System;
using System.Threading; 
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Threading.Tasks;
using System.Diagnostics;

namespace BindingGanttView
{
    public class COM_Component
    {
        Timer timer;
        private Guid _mostRecentlyParsedProjectGuid;
        public Guid mostRecentlyParsedProjectGuid
        {
            get { return _mostRecentlyParsedProjectGuid; }
            set { _mostRecentlyParsedProjectGuid = value; }
        }

        private Guid _mostRecentlyParsedPhaseGuid;
        public Guid mostRecentlyParsedPhaseGuid
        {
            get { return _mostRecentlyParsedPhaseGuid; }
            set { _mostRecentlyParsedPhaseGuid = value;}
        }

        private DateTime _mostRecentlyParsedPhaseStartTime;
        public DateTime mostRecentlyParsedPhaseStartTime
        {
            get { return _mostRecentlyParsedPhaseStartTime; }
            set { _mostRecentlyParsedPhaseStartTime = value; }
        }

        public COM_Component(Guid mostRecentlyParsedProjectGuid)
        {
            this.mostRecentlyParsedProjectGuid = mostRecentlyParsedProjectGuid;
            AutoResetEvent autoEvent = new AutoResetEvent(false);
            timer = new Timer(new TimerCallback(DoTheJob), autoEvent, 1000, 250);
            
            autoEvent.WaitOne(2000, false);
            timer.Change(0, 2000);
            Console.WriteLine("\nChanging period.\n");
            //autoEvent.WaitOne(5000, false);
            //timer.Dispose();
            //Console.WriteLine("\nDestroying timer.");

        }

        public void DoTheJob(Object stateInfo)
        {
            OnDataReceived();
        }

        public void StartListen()
        {
        }

        public void OnDataReceived()
        {
            // Push data to Gantt Chart
            var selectStatement = string.Format("TaskName = '{0}'", ProjectRepository.Instance.theTasks.Rows.Count);
            DataRow[] rows = ProjectRepository.Instance.theTasks.Select(selectStatement);

            // insert new if taskName is not in the table
            if (rows.Length < 1)
            {
                
                DataRow newRow = ProjectRepository.Instance.theTasks.NewRow();
                Guid thisGuid = Guid.NewGuid(); 
                newRow["TaskGuid"] = thisGuid;
                newRow["PlanID"] = ProjectRepository.Instance.defaultProjectName;
                newRow["TaskName"] = "none";
                newRow["ParentTaskGuid"] = mostRecentlyParsedProjectGuid;
                Console.WriteLine("|------>Parent guid: " + mostRecentlyParsedProjectGuid + " this guid: " + thisGuid);
                DateTime specificStartTime = DateTime.Now;
                newRow["TaskStartTime"] = specificStartTime;
                newRow["TaskDuration"] = TimeSpan.FromDays(14);  //convert seconds to days
                newRow["TaskPercentComplete"] = 0;
                //newRow["TaskType"] = GanttChart.Model.TaskType.BaseTask;
                ProjectRepository.Instance.theTasks.Rows.Add(newRow);

                Debug.WriteLine(Thread.CurrentThread.IsBackground);
            }
        }

        DateTime ConvertToDateTime(double unixTime)
        {
            var epoch = new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc);
            return epoch.AddSeconds(unixTime);
        }
    }
}
